'use strict';

var Errors = require('common-errors');
var emailChallenge = require('../utils/send-email.js');
var redisKey = require('../utils/key.js');

module.exports = function sendChallenge(opts) {
  var _this = this;

  var redis = this.redis;
  var username = opts.username;

  var userKey = redisKey(username, 'data');

  // TODO: record all attemps
  // TODO: add metadata processing on successful email challenge

  return redis.hget(userKey, 'active').then(function (active) {
    if (!active) {
      throw new Errors.HttpStatusError(404, 'user doesn\'t exist');
    }

    if (active === 'true') {
      throw new Errors.HttpStatusError(412, 'user is already active');
    }

    return emailChallenge.send.call(_this, username);
  });
};