'use strict';

var ld = require('lodash');
var redisKey = require('../utils/key.js');
var Promise = require('bluebird');
var isArray = Array.isArray;

module.exports = function getMetadata(username, _audience) {
  var redis = this.redis;

  var audience = isArray(_audience) ? _audience : [_audience];

  return Promise.map(audience, function getAudienceData(aud) {
    return redis.hgetallBuffer(redisKey(username, 'metadata', aud));
  }).then(function remapAudienceData(data) {
    var output = {};
    audience.forEach(function transform(aud, idx) {
      var datum = data[idx];
      if (datum) {
        output[aud] = ld.mapValues(datum, JSON.parse, JSON);
      } else {
        output[aud] = {};
      }
    });

    return output;
  });
};