'use strict';

var Errors = require('common-errors');
var redisKey = require('../utils/key.js');
var emailValidation = require('../utils/send-email.js');

module.exports = function requestPassword(opts) {
  var username = opts.username;
  var redis = this.redis;

  var userKey = redisKey(username, 'data');

  // TODO: make use of remoteip in security logs?
  // var remoteip = opts.remoteip;

  return redis.hmget(userKey, 'password', 'active', 'ban').bind(this).spread(function response(exists, isActive, isBanned) {
    if (exists === null) {
      throw new Errors.HttpStatusError(404, username + ' does not exist');
    }

    if (isActive !== 'true') {
      throw new Errors.HttpStatusError(412, 'account is not active');
    }

    if (isBanned === 'true') {
      throw new Errors.HttpStatusError(423, 'account has been locked');
    }

    return emailValidation.send.call(this, username, 'reset');
  })['return']({ success: true });
};